unit uFenster;
(* ******************************************************************** *)
(* K L A S S E : FENSTER                                                *)
(* -------------------------------------------------------------------- *)
(* Version     : 2.x                                                    *)
(* Autor       : (c) S. Spolwig - OSZ Handel I, Berlin 10997            *)
(* Beschreibung: Fenster fuer das Sortiertest                           *)
(*                                                                      *)
(* Compiler    : Delphi 4.0                                             *)
(* Aenderung   : V. 2.7 - 19-MAR-00                                     *)
(*                  2.8 - 22-FEB-02  - Wortliste                        *)
(* ******************************************************************** *)

interface
(* ==================================================================== *)
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Buttons, Menus,
  uWortGenerator,
  uzeit,
  uWortListe ;

type
  TFensterFrm = class(TForm)
    AusgabeLbox      : TListBox;
    EinstellungenGBox: TGroupBox;
    ListenlaengeRGrp : TRadioGroup;
    UPCaseCBox       : TCheckBox;
    WortLaengeEdt    : TEdit;
    WortLaengeLbl    : TLabel;
    AuswahlRGrp      : TRadioGroup;
    StatisktikPnl    : TPanel;
    SwapZahlLbl      : TLabel;
    VglLbl           : TLabel;
    VergleicheLbl    : TLabel;
    Fuellstand       : TProgressBar;
    SortBtn          : TButton;
    FeldRGrp         : TRadioGroup;
    MeldePnl         : TPanel;
    SwapLbl          : TLabel;
    ZeitLbl          : TLabel;
    ZeitPnl          : TPanel;
    OkBtn            : TBitBtn;
    MainMenu1        : TMainMenu;
    Schliessen1      : TMenuItem;
    Hilfe            : TMenuItem;
    Hinweise         : TMenuItem;
    Ueber            : TMenuItem;


    procedure FormCreate(Sender: TObject);
    procedure SortBtnClick(Sender: TObject);
    procedure OkBtnClick(Sender: TObject);
    procedure Schliessen1Click(Sender: TObject);
    procedure HinweiseClick(Sender: TObject);
    procedure UeberClick(Sender: TObject);

   private
    procedure Init;
    procedure ListeFuellen;
    procedure MaskeAktualisieren;
    procedure DatenAktualisieren;
   public
 end;

var
  FensterFrm : TFensterFrm;
  Liste      : TWortListe;


IMPLEMENTATION

uses uInfoBox;
(* ==================================================================== *)
{$R *.DFM}
var
AnzahlElemente : integer;

procedure TFensterFrm.FormCreate(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
  Liste := TWortListe.Create;
  Liste.Init;
  Liste.PegelAnzeigen(fuellstand);
  Init;
end;


procedure TFensterFrm.Init;
(* -------------------------------------------------------------------- *)
begin
  ListenlaengeRGrp.ItemIndex := 0;
  UPCaseCBox.Checked         := false;
  FeldRGrp.ItemIndex         := 0;
  MeldePnl.Caption           := '';
  VergleicheLbl.Caption      := '';
  SwapZahlLbl.Caption        := '';
  ZeitPnl.Caption            := '';
  Fuellstand.Position        := 0;
end;


procedure TFensterFrm.SortBtnClick(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
  if Liste.GetLen = 0
  then Meldepnl.Caption := 'Bitte erst Liste erzeugen!'
  else
   begin
     OKBtn.Enabled := false;
     AusgabeLBox.Clear;
     MeldePnl.Font.Color := clRed;
     MeldePnl.Caption    := 'Sortiere . . . . . ';
     Zeit.SetPause(1);
     Zeit.Start;

      case AuswahlRGrp.ItemIndex of
      0 : begin
            Liste.Bubblesort1;
          end;

      1 : begin
            Liste.Bubblesort2;
          end;

      2 : begin
            Liste.Bubblesort3;
          end;

      3 : begin
            Liste.Shakersort1;
          end;

      4 : begin
            Liste.Auswahlsort;
          end;

      5 : begin
            Liste.Quick;
          end;
      end;

      MeldePnl.Caption := '';
      Zeit.SetPause(1);
      Zeit.Stop;
      MaskeAktualisieren;
      OKBtn.Enabled := true;
    end;
end;



procedure TFensterFrm.OkBtnClick(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
  MeldePnl.Font.Color := clBlue;
  MeldePnl.Caption    := 'Liste fllen . . ... ';
  Zeit.SetPause(1);
  SortBtn.Enabled := false;
  DatenAktualisieren;
  MaskeAktualisieren;
  MeldePnl.Caption      := '';
  VergleicheLbl.Caption := '';
  SwapZahlLbl.Caption   := '';
  ZeitPnl.Caption       := '';
  SortBtn.Enabled := true;
end;

procedure TFensterFrm.Schliessen1Click(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
 AusgabeLBox.Clear;
  Liste.Free;
  Close;
end;

procedure TFensterFrm.ListeFuellen;
(* -------------------------------------------------------------------- *)
begin
  case FeldRGrp.ItemIndex of
      0 : Liste.Fuellen1;
      1 : Liste.Fuellen2;
      2 : Liste.Fuellen3;
   end;
end;


procedure TFensterFrm.MaskeAktualisieren;
(* -------------------------------------------------------------------- *)
var i : integer;
begin
  AusgabeLBox.Clear;
  Liste.First;

  for i := 1 to Liste.GetLen do
  begin
    AusgabeLBox.items.add(Liste.getelement);
    Liste.Next;
  end;

  VergleicheLbl.Caption := inttostr(Liste.GetVergleiche);
  SwapZahlLbl.Caption   := inttostr(Liste.GetSwaps);
  ZeitPnl.Caption       := Zeit.GetStopZeitForm;
  Fuellstand.Position   := 0;
end;


procedure TFensterFrm.DatenAktualisieren;
(* -------------------------------------------------------------------- *)
begin
  Liste.SetElemCase(UpCaseCBox.checked);
  Liste.SetElemLen(strtoint(WortLaengeEdt.Text));

  case ListenLaengeRGrp.ItemIndex of
      0 : AnzahlElemente := 1000;
      1 : AnzahlElemente := 2000;
      2 : AnzahlElemente := 5000;
      3 : AnzahlElemente :=10000;
      4 : AnzahlElemente :=15000;
      5 : AnzahlElemente :=25000;
      6 : AnzahlElemente :=50000;
      7 : AnzahlElemente :=100000;
  end;
  Liste.SetLen(AnzahlElemente);
  ListeFuellen;
end;

procedure TFensterFrm.HinweiseClick(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
  Showmessage ('Sort 2.0 ist ein Programm zum Untersuchen' + #13 +
               'des Effizienzverhaltens von Sortierprogrammen.' + #13 + #13 +
               'Eine Liste wird mit zufllig erzeugten Wrten' + #13 +
               'gleicher Lnge gefllt. Bei "Teilweise sortiert" ' + #13 +
               'wird an die sortierte Liste ein neues Wort angehngt,' + #13 +
               'das eingeordnet werden muss.'+ #13 +
               'Zeit: zeigt die effektive Dauer des Sortiervorganges.'+ #13 +
               'Die grafische Darstellung dauert natrlich lnger.'
               );
end;

procedure TFensterFrm.UeberClick(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
  Infobox.Show;
end;



END.
